package connector;

import org.robotservices.v02.exception.RSiException;
import org.robotservices.v02.profile.common.Ret_value;
import org.robotservices.v02.profile.invoker.IBasic_profile;
import org.robotservices.v02.profile.invoker.IData_push_profile;
import org.robotservices.v02.profile.invoker.InvokerProfileFactory;
import org.robotservices.v02.util.ConnectionInfo;

import com.fujitsu.rsi.helper.BasicProfileHelper;
import com.fujitsu.rsi.helper.DataPushProfileHelper;
import com.fujitsu.rsi.util.RESULT;

public class Connector {
	
	private static Connector own = new Connector();
	
	private InvokerProfileFactory factory = null;
	private IBasic_profile bp = null;
	private BasicProfileHelper helper = null;
	private long conv_id = 0;
	private IData_push_profile dpp = null;
	private boolean connect_state = false;

	private Connector(){
		
	}
	//CX^X𐶐
	public static Connector getInstance(){
		return own;
	}
	//RSNPT[oɐڑ
	public boolean connect(String end_point,String id,String pass){
		System.out.println("end_point:"+end_point+",id:"+id+",pass:"+pass);
		ConnectionInfo connectioninfo = new ConnectionInfo();
		connectioninfo.set_endpointname(end_point);
		try {
			factory = InvokerProfileFactory.newInstance(connectioninfo);
			factory.connect();
			bp = factory.getBasic_profile();
			Ret_value ret = bp.open(id, pass);
			helper = new BasicProfileHelper(ret);
			  if(helper.getResult() == RESULT.SUCCESS.getResult()){
				conv_id = helper.getConv_id();
				dpp = factory.getData_push_profile();
				dpp.start_profile(conv_id);
				System.out.println(conv_id);
			}else{
				return connect_state = false;
			}
			
		} catch (RSiException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return connect_state = false;
		}
		return connect_state = true;
	}
	
	public boolean disconnect(){	
		try {	
			if(connect_state == true){
			dpp.end_profile(conv_id);
			bp.close(conv_id);
			factory.disconnect();
			}	
		} catch (RSiException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
			return connect_state = false;
		}
		connect_state = false;
		return true;
	}
	
	public String push_data(String data){
		Ret_value ret = new Ret_value();
		String datas = "";
		try {
			dpp.push_data(conv_id, data, null);
			DataPushProfileHelper helper = new DataPushProfileHelper(ret);
			datas = helper.getDetail();
		} catch (RSiException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return datas;
	}
}
